// Copyright (c) 2011 RealSolid. Please read license.txt for applicable licensing.

#ifndef SOLIDCOIN_NOUI_H
#define SOLIDCOIN_NOUI_H

#include <string>
#include <boost/function.hpp>
#include "wallet.h"

typedef void wxWindow;
#define wxYES                   0x00000002
#define wxOK                    0x00000004
#define wxNO                    0x00000008
#define wxYES_NO                (wxYES|wxNO)
#define wxCANCEL                0x00000010
#define wxAPPLY                 0x00000020
#define wxCLOSE                 0x00000040
#define wxOK_DEFAULT            0x00000000
#define wxYES_DEFAULT           0x00000000
#define wxNO_DEFAULT            0x00000080
#define wxCANCEL_DEFAULT        0x80000000
#define wxICON_EXCLAMATION      0x00000100
#define wxICON_HAND             0x00000200
#define wxICON_WARNING          wxICON_EXCLAMATION
#define wxICON_ERROR            wxICON_HAND
#define wxICON_QUESTION         0x00000400
#define wxICON_INFORMATION      0x00000800
#define wxICON_STOP             wxICON_HAND
#define wxICON_ASTERISK         wxICON_INFORMATION
#define wxICON_MASK             (0x00000100|0x00000200|0x00000400|0x00000800)
#define wxFORWARD               0x00001000
#define wxBACKWARD              0x00002000
#define wxRESET                 0x00004000
#define wxHELP                  0x00008000
#define wxMORE                  0x00010000
#define wxSETUP                 0x00020000

inline int MyMessageBox(const std::string& message, const std::string& caption="Message", int style=wxOK, wxWindow* parent=NULL, int x=-1, int y=-1)
{
    printf("%s: %s\n", caption.c_str(), message.c_str());
    fprintf(stderr, "%s: %s\n", caption.c_str(), message.c_str());
    return 4;
}
#define wxMessageBox  MyMessageBox

inline int ThreadSafeMessageBox(const std::string& message, const std::string& caption, int style=wxOK, wxWindow* parent=NULL, int x=-1, int y=-1)
{
    return MyMessageBox(message, caption, style, parent, x, y);
}

inline bool ThreadSafeAskFee(int64 nFeeRequired, const std::string& strCaption, wxWindow* parent)
{
    return true;
}

inline void CalledSetStatusBar(const std::string& strText, int nField)
{
}

inline void CalledUpdateMiningUI(void)
{

}

inline void CalledUpdateMiningStatus(const std::string& strText)
{

}
inline void CalledUpdateMiningHash(int64 nMilli,std::vector<MINING_SPEEDS> *pSpeeds)
{
    //std::string output = TimeStr(GetSolidTime()) + " : "+strText;
    //pframeMain->m_MiningStatus->InsertItem(0,output);
    double dSec = nMilli/1000.0;
    for(int x=0;x<pSpeeds->size();x++)
    {
        MINING_POOL *pPool= &g_MiningPoolList[(*pSpeeds)[x].nID];
        pPool->qLastHashPerSec=(int64)((*pSpeeds)[x].qHash/dSec);
        pPool->qTotalHash+=(*pSpeeds)[x].qHash;
        pPool->qTotalShares=(*pSpeeds)[x].qShares;
    }
    delete pSpeeds;
}

inline void UIThreadCall(boost::function0<void> fn)
{
    fn();
}

inline void MainFrameRepaint()
{
}



#ifdef __WXMSW__

void ServiceCreate(void);
void ServiceDelete(void);
bool ServiceInit(int argc, std::string *argv);
bool ServiceQueryExit(void);

#else
inline void ServiceCreate(void) { }
inline void ServiceDelete(void) { }
inline bool ServiceQueryExit(void) { return false; }
bool AppInit(int argc, std::string *argv);
inline bool ServiceInit(int argc, std::string *argv)
{
    bool fRet = AppInit(argc, argv);
    return fRet;
}
#endif


#endif
